/usr/bin/patclean is in dist 1:3.5-36.0001-2.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 | #!/usr/bin/perl
eval 'exec perl -S $0 ${1+"$@"}'
if $running_under_some_shell;
# $Id: patclean.SH 31 2010-03-06 20:15:24Z rmanfredi $
#
# Copyright (c) 1991-1997, 2004-2006, Raphael Manfredi
#
# You may redistribute only under the terms of the Artistic Licence,
# as specified in the README file that comes with the distribution.
# You may reuse parts of this distribution only within the terms of
# that same Artistic Licence; a copy of which may be found at the root
# of the source tree for dist 4.0.
#
# $Log: patclean.SH,v $
# Revision 3.0.1.2 1994/01/24 14:30:17 ram
# patch16: now prefix error messages with program's name
# patch16: added ~/.dist_profile awareness
#
# Revision 3.0.1.1 1993/08/19 06:42:33 ram
# patch1: leading config.sh searching was not aborting properly
#
# Revision 3.0 1993/08/18 12:10:41 ram
# Baseline for dist 3.0 netwide release.
#
$version = '3.5';
$patchlevel = '0';
$RCSEXT = ',v' unless $RCSEXT;
$progname = &profile; # Read ~/.dist_profile
require 'getopts.pl';
&usage unless $#ARGV >= 0;
&usage unless &Getopts("ahnmV");
if ($opt_V) {
print STDERR "$progname $version PL$patchlevel\n";
exit 0;
} elsif ($opt_h) {
&usage;
}
$RCSEXT = ',v' unless $RCSEXT;
$ENV{'DIST'} = '/dev/null'; # Disable ~/.dist_profile
chop($pwd = `pwd`) unless -f '.package';
until (-f '.package') {
die "$progname: no .package file! Run packinit.\n" unless $pwd;
chdir '..' || die "$progname: can't cd ..: $!\n";
$pwd =~ s|(.*)/(.*)|$1|;
$prefix = $2 . '/' . $prefix;
}
if ($prefix) {
for (@ARGV) {
s/^/$prefix/ unless m|^[-/]|;
}
}
# We now are at the top level
&readpackage;
if ($opt_n) {
&newer; # Look for files newer than patchlevel.h
} elsif ($opt_a) {
open(MANI,"MANIFEST.new") || die "$progname: can't read MANIFEST.new: $!\n";
@ARGV = ();
while (<MANI>) {
s|^\./||;
next if m|^patchlevel.h|; # This file is built by hand
chop;
($_) = split(' ');
next if -d;
push(@ARGV,$_);
}
close MANI;
} elsif ($opt_m) {
open(MODS,"bugs/.mods$bnum") || die "$progname: no modification found.\n";
@ARGV = ();
while (<MODS>) {
next if m|^patchlevel.h$|; # This file is built by hand
chop;
($_) = split(' ');
push(@ARGV,$_);
}
close MODS;
}
# Set a temporary file for check outs
$TMPFILE = "/tmp/cl$$.tmp";
# Now loop over each file specified, doing a 'rcsclean'
foreach $file (@ARGV) {
if (-f $file) {
$files = &rcsargs($file);
@files = split(' ', $files);
$rlog = `rlog -rlastpat- $files 2>&1`;
($revs) = ($rlog =~ /selected revisions: (\d+)/);
if (!$revs) {
print "$progname: $file has never been checked in--checking in...\n";
system 'perl', '-S', 'patcil', '-p', $file;
$revs = 2; # At least null trunk + new fresh revision
}
# Look whether there is a branch
if ($revs == 1) {
$rlog = `rlog -r$revbranch $files 2>&1`;
($revs) = ($rlog =~ /selected revisions: (\d+)/);
$revs++; # add the base revision
}
# We must only give the name of the RCS revision file, i.e. $files[1]
if ($revs == 1) {
system "co -q -p$baserev $files[1] > $TMPFILE";
} else {
system "co -q -p$revbranch $files[1] > $TMPFILE";
}
if ($? == 0) {
system 'cmp', '-s', $file, $TMPFILE;
if ($? == 0) {
unlink $file;
print "$progname: $file removed.\n";
} else {
# Check in file and make sure all was ok
system 'perl', '-S', 'patcil', '-p', $file;
system "co -q -p$revbranch $files[1] > $TMPFILE";
if ($? == 0) {
system 'cmp', '-s', $file, $TMPFILE;
if ($? == 0) {
unlink $file;
print "$progname: $file removed.\n";
} else {
print "$progname: $file NOT removed.\n";
}
} else {
print "$progname: could not check out--$file NOT removed.\n";
}
}
} else {
print "$progname: no revision--$file NOT removed.\n";
}
}
}
unlink "$TMPFILE";
sub usage {
print STDERR <<EOM;
Usage: $progname [-ahnmV] [filelist]
-a : all the files in MANIFEST.new
-h : print this message and exit
-n : all the files newer than patchlevel.h
-m : all the modified files (which have been patciled)
-V : print version number and exit
EOM
exit 1;
}
sub newer {
open(FIND, "find . -type f -newer patchlevel.h -print | sort |") ||
die "Can't run find.\n";
open(NEWER,">.newer") || die "Can't create .newer.\n";
open(MANI,"MANIFEST.new");
while (<MANI>) {
($name,$foo) = split;
$mani{$name} = 1;
}
close MANI;
while (<FIND>) {
s|^\./||;
chop;
next if m|^MANIFEST|;
next if m|^PACKLIST$|;
if (!$mani{$_}) {
next if m|^MANIFEST.new$|;
next if m|^Changes$|;
next if m|^Wanted$|;
next if m|^.package$|;
next if m|^bugs|;
next if m|^users$|;
next if m|^UU/|;
next if m|^RCS/|;
next if m|/RCS/|;
next if m|^config.sh$|;
next if m|/config.sh$|;
next if m|^make.out$|;
next if m|/make.out$|;
next if m|^all$|;
next if m|/all$|;
next if m|^core$|;
next if m|/core$|;
next if m|^toto|;
next if m|/toto|;
next if m|^\.|;
next if m|/\.|;
next if m|\.o$|;
next if m|\.old$|;
next if m|\.orig$|;
next if m|~$|;
next if $mani{$_ . ".SH"};
next if m|(.*)\.c$| && $mani{$1 . ".y"};
next if m|(.*)\.c$| && $mani{$1 . ".l"};
next if (-x $_ && !m|^Configure$|);
}
print NEWER $_,"\n";
}
close FIND;
close NEWER;
print "Please remove unwanted files...\n";
sleep(2);
system '${EDITOR-vi} .newer';
die "Aborted.\n" unless -s '.newer' > 1;
@ARGV = split(' ',`cat .newer`);
}
sub readpackage {
if (! -f '.package') {
if (
-f '../.package' ||
-f '../../.package' ||
-f '../../../.package' ||
-f '../../../../.package'
) {
die "Run in top level directory only.\n";
} else {
die "No .package file! Run packinit.\n";
}
}
open(PACKAGE,'.package');
while (<PACKAGE>) {
next if /^:/;
next if /^#/;
if (($var,$val) = /^\s*(\w+)=(.*)/) {
$val = "\"$val\"" unless $val =~ /^['"]/;
eval "\$$var = $val;";
}
}
close PACKAGE;
}
sub rcsargs {
local($result) = '';
local($_);
while ($_ = shift(@_)) {
if ($_ =~ /^-/) {
$result .= $_ . ' ';
} elsif ($#_ >= 0 && do equiv($_,$_[0])) {
$result .= $_ . ' ' . $_[0] . ' ';
shift(@_);
} else {
$result .= $_ . ' ' . do other($_) . ' ';
}
}
$result;
}
sub equiv {
local($s1, $s2) = @_;
$s1 =~ s|.*/||;
$s2 =~ s|.*/||;
if ($s1 eq $s2) {
0;
} elsif ($s1 =~ s/$RCSEXT$// || $s2 =~ s/$RCSEXT$//) {
$s1 eq $s2;
} else {
0;
}
}
sub other {
local($s1) = @_;
($dir,$file) = ('./',$s1) unless local($dir,$file) = ($s1 =~ m|(.*/)(.*)|);
$dir = $TOPDIR . $dir if -d $TOPDIR . "$dir/RCS";
local($wasrcs) = ($file =~ s/$RCSEXT$//);
if ($wasrcs) {
`mkdir $dir` unless -d $dir;
$dir =~ s|RCS/||;
} else {
$dir .= 'RCS/';
`mkdir $dir` unless -d $dir;
$file .= $RCSEXT;
}
"$dir$file";
}
# Perform ~name expansion ala ksh...
# (banish csh from your vocabulary ;-)
sub tilda_expand {
local($path) = @_;
return $path unless $path =~ /^~/;
$path =~ s:^~([^/]+):(getpwnam($1))[$[+7]:e; # ~name
$path =~ s:^~:$ENV{'HOME'} || (getpwuid($<))[$[+7]:e; # ~
$path;
}
# Set up profile components into %Profile, add any profile-supplied options
# into @ARGV and return the command invocation name.
sub profile {
local($profile) = &tilda_expand($ENV{'DIST'} || '~/.dist_profile');
local($me) = $0; # Command name
$me =~ s|.*/(.*)|$1|; # Keep only base name
return $me unless -s $profile;
local(*PROFILE); # Local file descriptor
local($options) = ''; # Options we get back from profile
unless (open(PROFILE, $profile)) {
warn "$me: cannot open $profile: $!\n";
return;
}
local($_);
local($component);
while (<PROFILE>) {
next if /^\s*#/; # Skip comments
next unless /^$me/o;
if (s/^$me://o) { # progname: options
chop;
$options .= $_; # Merge options if more than one line
}
elsif (s/^$me-([^:]+)://o) { # progname-component: value
$component = $1;
chop;
s/^\s+//; # Trim leading and trailing spaces
s/\s+$//;
$Profile{$component} = $_;
}
}
close PROFILE;
return unless $options;
require 'shellwords.pl';
local(@opts);
eval '@opts = &shellwords($options)'; # Protect against mismatched quotes
unshift(@ARGV, @opts);
return $me; # Return our invocation name
}
|